<?php
class SurveyQuestionManage {

	var $question;
	var $question_id;
	var $question_type;
	var $WP_PLUGIN_URL;
	
	var $action;
	var $updateMsg;
	var $error;
	var $dataErrors = array();

	var $script_reDirect;
	var $script_updateBtn;
	var $script_questionAdd;		
	
	/**
	 * Survey Question Manage Constructor Function
	 *
	 * @return SurveyQuestionManage
	 */
	function SurveyQuestionManage() {
		$this->action = "";
		$this->updateMsg = "";
		$this->error = false;
	}
	
	
	/**
	 * Enter description here...
	 *
	 */
	function initSurveyQuestionManage() {
		$this->action = $_REQUEST['action'];
		
		switch ($this->action) {
			case 'ADD_QUESTION':
					$this->setLocalVars();
					$this->validateData();

					if (!$this->error) {
						$this->addQuestion();
					}
					
					// Set the update message error response
					if ($this->error) {
						if ($this->updateMsg2 == '') {
							//$this->updateMsg2 = "<span class=\"submissionErrors\">You have errors with your submission</span><br><br>";
							$this->script_reDirect = "\$dialogContent.find('#updateMsg2').html('<span class=\"submissionErrors\">You have errors with your submission</span><br><br>');";
						}
						
						$this->script_updateBtn = "jQuery('#updateBtn').attr('disabled', false);";
					}
										
					$this->displayJSON();
					break;
							
			case 'UPDATE_QUESTION':
					$this->setLocalVars();
					$this->validateData();

					if (!$this->error) {
						$this->updateQuestion();
					}
					
					// Set the update message error response
					if ($this->error) {
						if ($this->updateMsg2 == '') {
							//$this->updateMsg2 = "<span class=\"submissionErrors\">You have errors with your submission</span><br><br>";
							$this->script_reDirect = "\$dialogContent.find('#updateMsg2').html('<span class=\"submissionErrors\">You have errors with your submission</span><br><br>');";
						}
						
						$this->script_updateBtn = "jQuery('#updateBtn').attr('disabled', false);";
					}
										
					$this->displayJSON();				
					break;
					
			default:	
					break;
		}
	}
	
	
	/**
	 * Set local vars based on a form submission
	 *
	 */
	private function setLocalVars() {
		foreach ($_POST as $key => $value) {
			$this->{$key} = $value;	
		}		
	}
	
	
	/**
	 * Error check submitted info
	 *
	 */
	private function validateData() {
		$DataCleaner = new DataCleaner($this);

		$DataCleaner->validData($this->question, 'question_error');
				
		$this->error = $DataCleaner->error;
		$this->dataErrors = $DataCleaner->dataErrors;
	}
	
	
	/**
	 * Enter description here...
	 *
	 */
	private function addQuestion() {
		$tmpID = uniqid();
		
		if ($this->question_type == 1) {
			$answers = implode("|||", $this->answers);
		}
		
		$question = str_ireplace("'", "\'", $this->question);
		$answers = str_ireplace("'", "\'", $answers);
		
		/*$answers = addslashes($answers);
		$question = addslashes($this->question);*/
		
		$this->script_questionAdd = "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"questions[]\" id=\"key_$tmpID\" value=\"$tmpID\">');";
		$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"font_$tmpID\" id=\"font_$tmpID\" value=\"$this->font\">\');";
		$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"font_size_$tmpID\" id=\"font_size_$tmpID\" value=\"$this->font_size\">\');";
		$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"font_color_$tmpID\" id=\"font_color_$tmpID\" value=\"$this->font_color\">\');";		
		$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"priority_$tmpID\" id=\"priority_$tmpID\" value=\"1\">\');";
		$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"question_type_$tmpID\" id=\"question_type_$tmpID\" value=\"$this->question_type\">\');";
		
		// <a href=\"javascript:void(0);\" onclick=\"removeSFQuestion(\'$tmpID\\");\"><img src=\"" . $this->WP_PLUGIN_URL . "/survey_funnel/images/btn/delete_btn.png\" border=\"0\"></a>
		
		if ($this->question_type == 1) {
			$this->script_questionAdd .= "jQuery('#survey_frm').append('<input type=\"hidden\" name=\"answers_$tmpID\" id=\"answers_$tmpID\" value=\"".addslashes($answers)."\" />');";
			$this->script_questionAdd .= "jQuery('#survey_frm').append('<input type=\"hidden\" name=\"question_$tmpID\" id=\"question_$tmpID\" value=\"$question\">');";			
			$this->script_questionAdd .= "performSFQuestionAdd(\"$tmpID\", \"" . $this->WP_PLUGIN_URL . "\");";
		
		} elseif ($this->question_type == 2) {
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"answers_$tmpID\" id=\"answers_$tmpID\" value=\"\">');";
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"question_$tmpID\" id=\"question_$tmpID\" value=\"\">');";						
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").find(\"#question_$tmpID\").val(\$dialogContent.find(\"#question\").val());";
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").find(\"#answers_$tmpID\").val(\$dialogContent.find(\"#question\").val());";
			$this->script_questionAdd .= "performSFContentAdd(\"$tmpID\", \"" . $this->WP_PLUGIN_URL . "\");";
		}
		
// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation

		elseif($this->question_type ==3){
		
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"answers_$tmpID\" id=\"answers_$tmpID\" value=\"\">');";
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").append('<input type=\"hidden\" name=\"question_$tmpID\" id=\"question_$tmpID\" value=\"\">');";
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").find(\"#question_$tmpID\").val(\$dialogContent.find(\"#add\").val());";
			$this->script_questionAdd .= "performSFUserContentAdd(\"$tmpID\", \"" . $this->WP_PLUGIN_URL . "\");";
		}
//END		
		$this->script_questionAdd .= "\$dialogContent.dialog('destroy'); \$dialogContent.hide(); jQuery('#survey_funnel_question_flow').show(); updateSFColumns();";
		
	}

	
	/**
	 * Enter description here...
	 *
	 */
	private function updateQuestion() {
		$tmpID = $this->question_id;

		if ($this->question_type == 1) {
			$answers = implode("|||", $this->answers);
		}
		
		$question = str_ireplace("'", "\'", $this->question);
		$answers = str_ireplace("'", "\'", $answers);
		
		$this->script_questionAdd = "jQuery(\"#survey_frm\").find(\"#font_$tmpID\").val(\"$this->font\");";
		$this->script_questionAdd .= "jQuery(\"#survey_frm\").find(\"#font_size_$tmpID\").val(\"$this->font_size\");";
		$this->script_questionAdd .= "jQuery(\"#survey_frm\").find(\"#font_color_$tmpID\").val(\"$this->font_color\");";

		if ($this->question_type == 1) {
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").find(\"#question_$tmpID\").val(\"$question\");";
			$this->script_questionAdd .= "jQuery(\"#survey_frm\").find(\"#answers_$tmpID\").val(\"$answers\");";
			$this->script_questionAdd .= "jQuery(\"#li_$tmpID .display\").html(\"$question\");";
			$this->script_questionAdd .= "performSFQuestionUpdate(\"$tmpID\", \"" . $this->WP_PLUGIN_URL . "\");";			
		
		} elseif ($this->question_type == 2) {
			$this->script_questionAdd .= 'jQuery(\'#li_' . $tmpID . ' .display\').html($dialogContent.find(\'#question\').val());';
			//$this->script_questionAdd .= 'jQuery(\'#li_' . $tmpID . ' .display\').html(jQuery(\'<div/>\').text($dialogContent.find(\'#question\').val()).html());';			
			$this->script_questionAdd .= 'jQuery(\'#survey_frm\').find(\'#question_' . $tmpID . '\').val($dialogContent.find(\'#question\').val());';
			$this->script_questionAdd .= 'jQuery(\'#survey_frm\').find(\'#answers_' . $tmpID . '\').val($dialogContent.find(\'#question\').val());';
		}
		
// BEGIN Added By Arvind On 7-AUG-2013  For Add UserInformation

		elseif ($this->question_type==3){
			$this->script_questionAdd .= 'jQuery(\'#li_' . $tmpID . ' .display\').html($dialogContent.find(\'#question\').val());';
			$this->script_questionAdd .= 'jQuery(\'#survey_frm\').find(\'#question_' . $tmpID . '\').val($dialogContent.find(\'#add\').val());';
		
		}
		
//END

		$this->script_questionAdd .= '$dialogContent.dialog("destroy"); \$dialogContent.hide(); updateSFColumns();';		
	}
	
	
	/**
	 * Display the JSON info
	 *
	 */
	private function displayJSON() {
		$JSON = new JSON($this);
		$JSON->displayJSON();
		
		exit;
	}

	
} // End Survey Question Manage Class
?>